//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
TLargeInteger PerformanceCounterOverhead;


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

// MyDelay1 - use GetTickCount
void _stdcall MyDelay1(DWORD MSecs)
{
  DWORD BeginTime;

  BeginTime = GetTickCount();
  do {
  } while (GetTickCount() - BeginTime <= MSecs);
}

// MyDelay2 - use QueryPerformanceCounter
void _stdcall MyDelay2(DWORD MSecs)
{
  TLargeInteger rStart, rEnd, rFreq;

  // oWv
  QueryPerformanceFrequency(&rFreq);
  rEnd.QuadPart = MSecs * rFreq.QuadPart / 1000;

  // iJjeo}lpƭ
  QueryPerformanceCounter(&rStart);
  rEnd.QuadPart += rStart.QuadPart;

  // Dj
  do {
    QueryPerformanceCounter(&rFreq); // oثepƭ
  } while (rFreq.QuadPart <= rEnd.QuadPart);
}

// Calls the performance counter to determine the time overhead
TLargeInteger CalibratePerformanceCounterOverhead()
{
  TLargeInteger rStart, rEnd;

  QueryPerformanceCounter(&rStart);

  for (int i = 1; i <= 1000; i++)
    QueryPerformanceCounter(&rEnd);

  // oCIs QueryPerformanceCounter 禡ҪOɶ
  TLargeInteger r;
  r.QuadPart = rEnd.QuadPart - rStart.QuadPart;
  r.QuadPart /= 1000;
  return r;
}

// MyDelay3 - use QueryPerformanceCounter with Calibration
void _stdcall MyDelay3(DWORD MSecs)
{
  TLargeInteger rStart, rEnd, rFreq;

  // oWv
  QueryPerformanceFrequency(&rFreq);
  rEnd.QuadPart = MSecs * rFreq.QuadPart / 1000;

  // iJjeo}lpƭ
  QueryPerformanceCounter(&rStart);
  rEnd.QuadPart = rEnd.QuadPart + rStart.QuadPart
     - PerformanceCounterOverhead.QuadPart * 2;

  // Dj
  do {
    QueryPerformanceCounter(&rFreq); // oثepƭ
  } while (rFreq.QuadPart <= rEnd.QuadPart);
}


void __fastcall TForm1::FormCreate(TObject *Sender)
{
  // Calibration for MyDelay3 function
  PerformanceCounterOverhead = CalibratePerformanceCounterOverhead();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnStartClick(TObject *Sender)
{
  const AnsiString DescStr[4] = {"Win32 API Sleep",
    "GetTickCount version",
    "QueryPerformanceCounter version",
    "Calibrated QueryPerformanceCounter version"};

  // ഫզ, w]Ȭ 100 
  int TryTimes = StrToIntDef(txtTimes->Text, 100);
  txtTimes->Text = IntToStr(TryTimes);

  // ഫɶ, w]Ȭ 100 @
  int Delaytime = StrToIntDef(txtDelay->Text, 100);
  txtDelay->Text = IntToStr(Delaytime);

  for (int TestKind = 0; TestKind < 4; TestKind++) {

    void _stdcall (*DelayProc)(DWORD MSecs);

    // N DelayProc Vҭnժ禡
    switch (TestKind) {
      case 0: DelayProc = Sleep;
              break;
      case 1: DelayProc = MyDelay1;
              break;
      case 2: DelayProc = MyDelay2;
              break;
      case 3: DelayProc = MyDelay3;
              break;
    }

    TLargeInteger rStart, rEnd, rFreq;

    // O}lɶ
    QueryPerformanceCounter(&rStart);

    for (int TryNo = 1; TryNo <= TryTimes; TryNo++)
      DelayProc(Delaytime);

    // OɶípƩҪOɶ, 쬰@
    QueryPerformanceCounter(&rEnd);
    QueryPerformanceFrequency(&rFreq); // oWv
    float ElapsedTime = (rEnd.QuadPart - rStart.QuadPart) / (rFreq.QuadPart / 1000);

    mmoResult->Lines->Add(Format("%s\r\nOɶ: %f @\r\n~t: %f @\r\n",
      OPENARRAY(TVarRec, (DescStr[TestKind], ElapsedTime, ElapsedTime - Delaytime * TryTimes))));
  }
}
//---------------------------------------------------------------------------
