//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
                       
#include <clipbrd.hpp>

#include "main.h"
#include "xWindows.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::btnCopyToClipBoardClick(TObject *Sender)
{
  Clipboard()->Assign(imgResult->Picture->Bitmap);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::tmrDelayTimer(TObject *Sender)
{
  tmrDelay->Enabled = false;
  GrabImage(FOldWnd);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button1Click(TObject *Sender)
{
  if (dlgSavePicture->Execute())
    imgResult->Picture->SaveToFile(dlgSavePicture->FileName);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Button2Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  Caption = Application->Title;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  // ƹ
  ReleaseCapture();
  Screen->Cursor = crDefault;

  if (FOldWnd != 0) DrawWindowFocusRect((THandle)Handle, DEFAULT_FOCUSRECT_WIDTH);

  FCapturing = false;
  Caption = Application->Title;
}
//---------------------------------------------------------------------------

HWND FindTopmostWindow1(HWND ParentWnd, TPoint PT)
{
  TRect R;

  HWND Wnd = GetWindow(ParentWnd, GW_CHILD); // oĤ@Ӥl

  while (Wnd != 0) {
    GetWindowRect(Wnd, &R); // oxΰϰ

    if (IsWindowVisible(Wnd) && PtInRect(&R, PT)) {
      if (Wnd == Application->MainForm->Handle)  // { Main Form
        return 0;

      return FindTopmostWindow1(Wnd, PT); // , jIsol
    }

    Wnd = GetWindow(Wnd, GW_HWNDNEXT); // oU@ siblings 
  }

  return ParentWnd; // 䤣, NOڭ̭n䪺
}

void __fastcall TMainForm::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  HWND Wnd;
  TPoint P;

  if (!FCapturing) return;

  Wnd = (HWND)FindTopmostWindow((THandle)GetDesktopWindow(), ClientToScreen(Point(X, Y)));
  if (FOldWnd != Wnd && Wnd != 0) {

    if (FOldWnd != 0) DrawWindowFocusRect((THandle)FOldWnd, DEFAULT_FOCUSRECT_WIDTH);
    DrawWindowFocusRect((THandle)Wnd, DEFAULT_FOCUSRECT_WIDTH);

    lblHandle->Caption = IntToHex((int)Wnd, 16);

    lblCaption->Caption = GetWindowCaption((THandle)Wnd);
    lblClassName->Caption = GetWindowClassName((THandle)Wnd);

    TRect R;
    GetWindowRect(Wnd, &R);
    lblRect->Caption = Format("(%d,%d)-(%d,%d) %dx%d",
      OPENARRAY(TVarRec,
      ((int)R.left,
       (int)R.top,
       (int)R.right,
       (int)R.bottom,
       (int)(R.right - R.left),
       (int)(R.bottom - R.top))));

    FOldWnd = Wnd;

    // Npɾs}
    tmrDelay->Enabled = false;
    tmrDelay->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GrabImage(HWND Wnd)
{
  HDC DC;
  TRect R, R1, R2;
  bool bOverlapped;

  DC = GetWindowDC(Wnd);
  GetWindowRect(Wnd, &R);
  R2 = BoundsRect;
  bOverlapped = IntersectRect(&R1, &R, &R2);
  MapWindowPoints(HWND_DESKTOP, Wnd, (PPOINT)&R, 2);
  OffsetRect(&R, -R.left, -R.top);

  if (bOverlapped) WindowState = wsMinimized;
  DrawWindowFocusRect((THandle)Wnd, DEFAULT_FOCUSRECT_WIDTH);

  imgResult->Picture->Bitmap->Width = R.right;
  imgResult->Picture->Bitmap->Height = R.bottom;

  BitBlt(imgResult->Canvas->Handle, 0, 0, R.right, R.bottom, DC, 0, 0, SRCCOPY);
  imgResult->Refresh();

  DrawWindowFocusRect((THandle)Wnd, DEFAULT_FOCUSRECT_WIDTH);
  if (bOverlapped) WindowState = wsNormal;

  ReleaseDC(Wnd, DC);
}


void __fastcall TMainForm::speCaptureMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  TPoint Pt;

  if (Button != mbLeft) return;

  FCapturing = true;
  FOldWnd = 0;
  Caption = Application->Title + " Capturing ...";
  Screen->Cursor = crCross;

  // IsoӪ, ҦǨ form  mouse message |ɨ
  // ثe CapturedControl - speCapture ...
  SetCaptureControl(NULL);
  // Is SetCapture , DUC, _h|_ƹT
  // 1. Is ReleaseCapture API
  // 2. ϥΪƹΫU䥦ƹ
  SetCapture(Handle);

  // Bzثey
  Pt = Point(X, Y);
  Pt = ScreenToClient(speCapture->ClientToScreen(Pt));
  FormMouseMove(this, Shift, X, Y);
}
//---------------------------------------------------------------------------


