//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "ScreenCanvas.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CGRID"
#pragma resource "*.dfm"
TMainForm *MainForm;

const int DOT_SIZE = 20;

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::grdColorChange(TObject *Sender)
{
  imgMain->Canvas->Brush->Color = grdColor->ForegroundColor;
  FDesktopBits->Canvas->Brush->Color = grdColor->ForegroundColor;
  FDesktopBits->Canvas->Pen->Color = grdColor->ForegroundColor;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  FDrawing = false;

  FCursorBits = new Graphics::TBitmap;
  FCursorBits->LoadFromFile("hammer.bmp");
  FCursorBits->Transparent = true;
  FCursorBits->TransparentMode = tmAuto;

  FDesktopBits = new Graphics::TBitmap;

  grdColor->ForegroundIndex = 9; // 
  grdColorChange(grdColor);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormKeyPress(TObject *Sender, char &Key)
{
  if (Key == 27) Close();        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  delete FCursorBits;
  delete FDesktopBits;        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::pnlRightResize(TObject *Sender)
{
  grdColor->Width = pnlRight->ClientWidth;
  grdColor->Height = pnlRight->ClientHeight;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::imgMainMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  FDrawing = true;        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::imgMainMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  FDrawing = false;        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::imgMainMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  TPoint Pt;
  TRect R;

  GetCursorPos(&Pt);

  if (Pt.x != FCursorPos.x || Pt.y != FCursorPos.y) {

    R = Rect(0, 0, FCursorBits->Width, FCursorBits->Height);
    OffsetRect(&R, FCursorPos.x, FCursorPos.y);
    imgMain->Canvas->CopyRect(R, FDesktopBits->Canvas, R);

    if (FDrawing) {
      R = Rect(Pt.x, Pt.y, Pt.x + DOT_SIZE, Pt.y + DOT_SIZE);
      FDesktopBits->Canvas->Ellipse(Pt.x, Pt.y, Pt.x + DOT_SIZE, Pt.y + DOT_SIZE);
      imgMain->Canvas->CopyRect(R, FDesktopBits->Canvas, R);
    }

    imgMain->Canvas->Draw(Pt.x, Pt.y, FCursorBits);

    FCursorPos = Pt;
  }

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GrabScreenImage()
{
  FDesktopBits->Width = ClientWidth;
  FDesktopBits->Height = ClientHeight;

  TScreenCanvas* SC = new TScreenCanvas;
  try {
    BitBlt(FDesktopBits->Canvas->Handle, 0, 0, ClientWidth,
        ClientHeight, SC->Handle, 0, 0, SRCCOPY);

    imgMain->Picture->Bitmap->Assign(FDesktopBits);
  } __finally {
    delete SC;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMSetFocus(TWMSetFocus& Message)
{
  ShowCursor(false);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMKillFocus(TWMKillFocus& Message)
{
  ShowCursor(true);
}

void __fastcall TMainForm::FormActivate(TObject *Sender)
{
  GrabScreenImage();        
}
//---------------------------------------------------------------------------

