//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <cpl.h>
#include <cpl.hpp>

#include "main.h"
#include "xFiles.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void TMainForm::ProcessNode(TTreeNode* ANode)
{
  HINSTANCE hLib;
  TCPLApplet CPLProc;  // V CPlApplet 禡禡
  int iCount;
  TTreeNode* NewNode;

  // ΨӨoTc
  TCPLInfo CPLInfo;
  TNewCPLInfo NewCPLInfo;

  // O󪺦W١Byzιϥ
  char sName[256], sInfo[256];
  HICON hAppIcon;

  // J CPL , ɦWYO`ID
  hLib = LoadLibrary(ANode->Text.c_str());
  if (!hLib) {
    ANode->Text = ANode->Text + " - Can''t be loaded !!";
    return;
  }

  try {
    // o CPlApplet 禡}
    CPLProc = (TCPLApplet)GetProcAddress(hLib, "CPlApplet");
    if (!CPLProc) return; // Tw CPlApplet 禡

    if (CPLProc((THandle)Handle, CPL_INIT, 0, 0) == 0) return; // l applet
      
    // o CPL ɤ䴩xƥ
    iCount = CPLProc((THandle)Handle, CPL_GETCOUNT, 0, 0);
      
    for (int i = 0; i < iCount; i++) {

      // e CPL_INQUIRE T, o TCPLInfo c
      memset(&CPLInfo, 0, sizeof(TCPLInfo));
      if (CPLProc((THandle)Handle, CPL_INQUIRE, i, Longint(&CPLInfo)) != 0) return;

      // q귽JW, yzιϥ
      LoadString(hLib, CPLInfo.idName, sName, sizeof(sName));
      LoadString(hLib, CPLInfo.idInfo, sInfo, sizeof(sInfo));
      hAppIcon = LoadIcon(hLib,
        MAKEINTRESOURCE(CPLInfo.idIcon));

      // Y@Ȭ CPL_DYNAMIC_RES, h...
      if (CPLInfo.idName == CPL_DYNAMIC_RES ||
         CPLInfo.idInfo == CPL_DYNAMIC_RES ||
         CPLInfo.idIcon == CPL_DYNAMIC_RES) {

        // e CPL_NEWINQUIRE T, o TNewCPLInfo c
        memset(&NewCPLInfo, 0, sizeof(TNewCPLInfo));
        NewCPLInfo.dwSize = sizeof(TNewCPLInfo);
        if (CPLProc((THandle)Handle, CPL_NEWINQUIRE, i, (Longint)&NewCPLInfo) != 0) return;

        // oW
        if (CPLInfo.idName == CPL_DYNAMIC_RES)
          StrCopy(sName, NewCPLInfo.szName);

        // oyz
        if (CPLInfo.idInfo == CPL_DYNAMIC_RES)
          StrCopy(sInfo, NewCPLInfo.szInfo);

        // oϥ
        if (CPLInfo.idIcon == CPL_DYNAMIC_RES)
          hAppIcon = NewCPLInfo.hIcon;
      }

      CPLProc((THandle)Handle, CPL_STOP, i, CPLInfo.lData);

      // C@إߤl`I
      strcat(sName, " - ");
      strcat(sName, sInfo);
      NewNode = tvwCPL->Items->AddChild(ANode, sName);
      // Q Data ݩʨxs Icon  Handle
      NewNode->Data = hAppIcon;
    }

    CPLProc((THandle)Handle, CPL_EXIT, 0, 0);
  } __finally {
    FreeLibrary(hLib); // OѤF CPL 
  }
}

void __fastcall TMainForm::GetCPlInformation()
{
  int iResult;
  TSearchRec SearchRec;
  TTreeNode* NewNode;

  // }lMtΥؿU CPL ɮ
  iResult = FindFirst(SystemDirFile("*.CPL").c_str(), faAnyFile, SearchRec);
  while (iResult == 0) {

    // C@ CPL , Nإ߷s`I, ñN`ID]ɦW
    NewNode = tvwCPL->Items->AddChild(NULL,
      AnsiLowerCase(SearchRec.Name));


//    OutputDebugString(SearchRec.Name.c_str());
    // AIs ProcessNode Bzs`I
    ProcessNode(NewNode);
    // N`Ii}
    NewNode->Expand(true);

    // MU@ CPL 
    iResult = FindNext(SearchRec);
  }
  FindClose(SearchRec);

  // ܲĤ@Ӹ`I
  tvwCPL->Selected = tvwCPL->Items->GetFirstNode();
}

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  // oҦ CPL ɤαxT
  GetCPlInformation();
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::tvwCPLChange(TObject *Sender, TTreeNode *Node)
{
  int num;

  if (Node->Level == 0) { // YI CPL 
    if (Node->HasChildren) // Y]t(l`I)...
      num = Node->GetLastChild()->Index + 1;
    else
      num = 0;

    lblDescription->Caption = Format("%s ֦ %d ӱx",
      OPENARRAY(TVarRec, (Node->Text, num)));
  } else { // YIﱱx
    lblDescription->Caption = Node->Text;
    // wϥ
    imgIcon->Picture->Icon->Handle = HICON(Node->Data);
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::tvwCPLDblClick(TObject *Sender)
{
  HINSTANCE hLib;
  TCPLApplet CPLProc;  // V CPlApplet 禡禡
  TTreeNode* ANode;

  TCPLInfo CPLInfo; // ΨӨoTc

  ANode = tvwCPL->Selected;
  if (ANode == NULL || ANode->Level != 1) return;

  // J CPL , CPL ɦWY`I`ID
  hLib = LoadLibrary(ANode->Parent->Text.c_str());
  if (!hLib) {
    ShowMessage("LkJ " + ANode->Parent->Text);
    return;
  }

  // o CPlApplet 禡}
  CPLProc = (TCPLApplet)GetProcAddress(hLib, "CPlApplet");
  if (CPLProc) {
    THandle h = (THandle)Handle; // conform to type checking

    // Ұʤ, sYO`I (ANode.Index)
    CPLProc(h, CPL_INIT, 0, 0);
    memset(&CPLInfo, 0, sizeof(TCPLInfo));
    CPLProc(h, CPL_INQUIRE, ANode->Index, (Longint)&CPLInfo);
    CPLProc(h, CPL_DBLCLK, ANode->Index, CPLInfo.lData);
    CPLProc(h, CPL_STOP, ANode->Index, CPLInfo.lData);
    CPLProc(h, CPL_EXIT, 0, 0);
  }
  FreeLibrary(hLib); // OF CPL 
}
//---------------------------------------------------------------------------

