//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "dihook\dihook.h"
#include "xDesktop.hpp"
#include "xFonts.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;

const char* ESSAY_FILENAME    = "essay.txt";

const char* REGISTRY_KEY      = "Software\\Jethro\\Desktop Illusionist";

const char* SEC_GENERAL       = "General";

const char* REG_SHOWWALLPAPER = "ShowWallPaper";
const char* REG_FONT          = "Font";
const char* REG_SEPCOLOR      = "Seperator Color";

//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  // Y Active Desktop Ұʤ, h{
  if (GetActiveDesktopWindow()) {
    ShowMessage("This program will not function whenever Active Desktop exists");
    Application->Terminate(); // {
    return;
  }

  // ]wε{
  SetMainWindow(Handle);

  // I]w hook, P subclass ӵΨ
  if (!SetDeskHook(GetDesktopListView())) {
    ShowMessage("Hook failed");
    Application->Terminate(); // {
    return;
  }

  // qtεnŪrΤΤjuC
  TRegIniFile* r = new TRegIniFile(REGISTRY_KEY);
  try {
    mnuShowDesktopWallPaper->Checked = r->ReadBool(SEC_GENERAL, REG_SHOWWALLPAPER, true);
    StringToFont(r->ReadString(SEC_GENERAL, REG_FONT, "\"sө\", 11, [], [clWhite]"), dlgFont->Font, true);
    dlgSepColor->Color = StringToColor(r->ReadString(SEC_GENERAL, REG_SEPCOLOR, "clLime"));
  } __finally {
    delete r;
  }

  // Ju
  mmoEssay->Lines->LoadFromFile(ESSAY_FILENAME);

  // ]wܮ६
  SetShowDesktopWallPaper(mnuShowDesktopWallPaper->Checked);

  // ]wuܰѼ
  ApplyColor();
  ApplyFont();
  ApplyEssay();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  // xsu
  mmoEssay->Lines->SaveToFile(ESSAY_FILENAME);

  // xsuܰѼ
  TRegIniFile* r = new TRegIniFile(REGISTRY_KEY);
  try {
    r->WriteBool(SEC_GENERAL, REG_SHOWWALLPAPER, mnuShowDesktopWallPaper->Checked);
    r->WriteString(SEC_GENERAL, REG_FONT, FontToString(dlgFont->Font, true));
    r->WriteString(SEC_GENERAL, REG_SEPCOLOR, ColorToString(dlgSepColor->Color));
  } __finally {
    delete r;
  }

  // Ѱ hook
  SetDeskHook(0);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuExitClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuWriteClick(TObject *Sender)
{
  ApplyEssay();        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuSeperatorColorClick(TObject *Sender)
{
  if (dlgSepColor->Execute())
    ApplyColor();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuFontClick(TObject *Sender)
{
  if (dlgFont->Execute())
    ApplyFont();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuHideClick(TObject *Sender)
{
  // ëe]wu
  ApplyEssay();

  ShowWindow(Handle, SW_HIDE);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ApplyColor()
{
  // ]wuC
  SetEssayColor(dlgSepColor->Color, dlgFont->Font->Color);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ApplyEssay()
{
  // Nu]w DLL
  for (int i = 0; i < mmoEssay->Lines->Count; i++)
    SetEssay(i, mmoEssay->Lines->Strings[i].c_str());

  SetEssayCount(mmoEssay->Lines->Count);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ApplyFont()
{
  TLogFont LF;

  // ]wur, Pɳ]wC
  GetObject(dlgFont->Font->Handle, sizeof(TLogFont), &LF);
  SetEssayFont(&LF);
  ApplyColor();
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::mnuInsertSeperatorClick(TObject *Sender)
{
  mmoEssay->Lines->Add("-");        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormActivate(TObject *Sender)
{
  ShowWindow(Application->Handle, SW_HIDE);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuShowDesktopWallPaperClick(TObject *Sender)
{
  // O_ܮ६
  mnuShowDesktopWallPaper->Checked = !mnuShowDesktopWallPaper->Checked;
  SetShowDesktopWallPaper(mnuShowDesktopWallPaper->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WMSysCommand(TWMSysCommand& Message)
{
  // UsΥѨtο, uNð_
  if (Message.CmdType == SC_CLOSE)
    ShowWindow(Handle, SW_HIDE);
  else
    TForm::Dispatch(&Message);
}
