//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>

#include "util.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TPageControl *PageControl;
        TTabSheet *tabPreview;
        TImage *imgPreview;
        TTabSheet *tabColors;
        TListBox *lbxColors;
        TGroupBox *gbxColors;
        TLabel *lblRValue;
        TLabel *lblGValue;
        TLabel *lblBValue;
        TPanel *pnlColor;
        TTabSheet *tabCursor;
        TListBox *lbxCursors;
        TGroupBox *gbxCursors;
        TLabel *Label4;
        TLabel *Label1;
        TEdit *txtCursorFile;
        TPanel *pnlCursor;
        TImage *imgCursor;
        TTabSheet *tabSound;
        TListBox *lbxSounds;
        TGroupBox *gbxSounds;
        TLabel *Label2;
        TEdit *txtSoundFile;
        TPanel *pnlPlaySound;
        TSpeedButton *btnPlaySound;
        TSpeedButton *btnStopPlay;
        TTabSheet *tabFonts;
        TListBox *lbxFonts;
        TGroupBox *gbxFonts;
        TLabel *lblFontName;
        TLabel *lblFontSize;
        TLabel *lblFontStyle;
        TTabSheet *tabDesktop;
        TListBox *lbxDesktop;
        TGroupBox *gbxDesktop;
        TNotebook *nbkDesktop;
        TLabel *Label7;
        TEdit *txtDesktopFile;
        TPanel *pnlIcon;
        TImage *imgIcon;
        TButton *btnPreview;
        TLabel *lblHorizontal;
        TLabel *lblVertical;
        TLabel *lblBorderWidth;
        TLabel *lblTitleWrap;
        TComboBox *cbxMetricsKind;
        TMainMenu *mnuMain;
        TMenuItem *mnuFile;
        TMenuItem *mnuOpen;
        TMenuItem *N1;
        TMenuItem *mnuApply;
        TMenuItem *N3;
        TMenuItem *mnuCurrent;
        TMenuItem *N2;
        TMenuItem *mnuExit;
        TMenuItem *mnuHelp;
        TMenuItem *mnuAbout;
        TOpenDialog *dlgOpen;
        void __fastcall mnuOpenClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall lbxColorsDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall lbxCursorsDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall lbxFontsDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall lbxDesktopDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall lbxColorsClick(TObject *Sender);
        void __fastcall lbxCursorsClick(TObject *Sender);
        void __fastcall lbxSoundsClick(TObject *Sender);
        void __fastcall lbxFontsClick(TObject *Sender);
        void __fastcall btnPlaySoundClick(TObject *Sender);
        void __fastcall lbxDesktopClick(TObject *Sender);
        void __fastcall cbxMetricsKindChange(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall mnuApplyClick(TObject *Sender);
        void __fastcall btnPreviewClick(TObject *Sender);
        void __fastcall mnuCurrentClick(TObject *Sender);
        void __fastcall mnuExitClick(TObject *Sender);
        void __fastcall mnuAboutClick(TObject *Sender);
private:	// User declarations
    AnsiString FThemePath, FThemeName;

    // ========= Theme Data Start ========== //
    AnsiString FMyIcons[TMyIcon_MAX + 1];
    TColor FMyColors[TMyColor_MAX + 1];
    AnsiString FMyCursors[TMyCursor_MAX + 1];
    AnsiString FMySounds[TMySound_MAX + 1];
    TLogFont FMyFonts[TMyFont_MAX + 1];

    AnsiString FWallPaper, FScreenSaver;
    int FWallPaperStyle, FTileWallPaper;
    AnsiString FPattern;

    TIconMetrics FIM;
    TNonClientMetrics FNM;
    // ========= Theme Data End ========== //

    HICON FMyCursorIcons[TMyCursor_MAX + 1];
    HICON FMyIconIcons[TMyIcon_MAX + 1];
    Graphics::TBitmap* FWallPaperBits;

    AnsiString __fastcall ReadThemeItem(TIniFile* IniFile, AnsiString Section, AnsiString Ident);
    void __fastcall ReadThemeFile(AnsiString Filename);
    
    void __fastcall LoadDesc();
    void __fastcall LoadThemeComponents();

    void __fastcall DrawTheme(TCanvas* DrawCanvas);
    void __fastcall UpdateCaption();
    void __fastcall ApplyTheme();
    void __fastcall LoadCurrentSettings();

    // paint preview scene
    void __fastcall DrawBackgound(TCanvas* ACanvas);
    void __fastcall DrawIcons(TCanvas* ACanvas);
    void __fastcall DrawBorderIcon(TCanvas* ACanvas, TRect ARect, int Kind);
    void __fastcall DrawScrollButton(TCanvas* ACanvas, TRect ARect, int Kind);
    void __fastcall DrawWindows(TCanvas* ACanvas);
    void __fastcall ShowPattern();
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
