#include <vcl.h>
#pragma hdrstop

#define utilCPP
#include "util.h"
#include "xFiles.hpp"

//---------------------------------------------------------------------------

#pragma package(smart_init)

bool StringToBuffer(AnsiString S, void* Buf, int Size)
{
  S = S.Trim(); // hkť
  System::PByte P = (System::PByte)Buf;
  ZeroMemory(P, Size);

  int ByteNo = 0;
  bool bExit = false;
  while (ByteNo < Size && S.Length() > 0) {

    if (bExit) return false;

    int i = S.Pos(" ");
    if (i == 0) bExit = true;

    AnsiString sTemp;
    if (bExit)
      sTemp = S;
    else
      sTemp = S.SubString(1, i - 1);

    *(P + ByteNo) = StrToIntDef(sTemp, -1);
    S.Delete(1, i);
    ByteNo++;
  }

  return (ByteNo == Size);
}

AnsiString BufferToString(void* Buf, int Size)
{
  AnsiString value = "";

  Byte* P = (Byte*)Buf;
  int i = 0;
  while (i < Size) {
    value = value + IntToStr(*P) + " ";
    P++;
    i++;
  }

  return value.TrimRight();
}

HCURSOR MyLoadCursor(TMyCursor No, AnsiString FileName)
{
  FileName = FileName.UpperCase();

  if (FileExists(FileName)) {
    AnsiString Ext = ExtractFileExt(FileName);
    if (Ext == ".CUR" || Ext == ".ANI")
      return LoadCursorFromFile(FileName.c_str());
  } else if (FileName == "") // Load windows default cursor (undocumented)
    return LoadImage(0, PChar(MyCursorNo1[No]), IMAGE_CURSOR, 0, 0, 0x240);

  return 0; // ѪܶǦ^ 0
}

AnsiString GetMyWallPaperFile()
{
  char Buf[256];

  GetWindowsDirectory(Buf, sizeof(Buf));
  return PathWithSlash(Buf, '\\') + "THEMEMGR.BMP";
}

TColor CalcForeColor(TColor mc)
{
  // calculate the Y value (G) of YIQ color model
  if (0.299 * GetRValue(mc) + 0.587 * GetGValue(mc) +
    0.114 * GetBValue(mc) < 127)
    return clWhite;
  else
    return clBlack;
}


