//---------------------------------------------------------------------------

#ifndef utilH
#define utilH

#ifdef utilCPP
#define VAR
#define INI(x) = x
#else
#define VAR extern
#define INI(x)
#endif

//---------------------------------------------------------------------------
enum TMyColor {ActiveTitle, GradientActiveTitle, Background, Hilight,
    HilightText, TitleText, Window, WindowTextColor, ScrollBar,
    InactiveTitle, GradientInactiveTitle, MenuColor, WindowFrame, MenuText,
    ActiveBorder, InactiveBorder, AppWorkspace, ButtonFace, ButtonShadow,
    GrayText, ButtonText, InactiveTitleText, ButtonHilight, ButtonDkShadow,
    ButtonLight, InfoText, InfoWindow, TMyColor_MAX = InfoWindow};

enum TMyCursor {mcrArrow, mcrHelp, mcrAppStarting, mcrWait, mcrNWPen, mcrNo,
    mcrSizeNS, mcrSizeWE, mcrCrosshair, mcrIBeam, mcrSizeNWSE, mcrSizeNESW,
    mcrSizeAll, mcrUpArrow, TMyCursor_MAX = mcrUpArrow};

enum TMySound {sdDefault, dsAppGPFault, dsMaximize, dsMenuCommand,
    dsMenuPopup, dsMinimize, dsOpen, dsClose, dsRestoreDown, dsRestoreUp,
    dsRingIn, dsRingout, dsSystemAsterisk, dsSystemDefault,
    dsSystemExclamation, dsSystemExit, dsSystemHand, dsSystemQuestion,
    dsSystemStart, dsEmptyRecycleBin, TMySound_MAX = dsEmptyRecycleBin};

enum TMyFont {mfIcon, mfCaptionFont, mfsmCaptionFont, mfMenuFont,
    mfStatusFont, mfMessageFont, TMyFont_MAX = mfMessageFont};

enum TMyIcon {mcMyComputer, mcNeighbor, mcRecycleBinFull,
    mcRecycleBinEmpty, TMyIcon_MAX = mcRecycleBinEmpty};

enum TMyDesktop {mdWallPaper, mdBackgroundPattern, mdScreenSaver,
    mdMetrics, TMyDesktop_MAX = mdMetrics};

VAR const char* secColors    INI("Control Panel\\Colors");
VAR const char* secCursors   INI("Control Panel\\Cursors");
VAR const char* secDesktop   INI("Control Panel\\Desktop");
VAR const char* secMetrics   INI("Metrics");
VAR const char* secBoot      INI("Boot");

// tC: ΩtεnΧGyz
const char* MyColorID[]  =
    {"ActiveTitle", "GradientActiveTitle", "Background", "Hilight",
    "HilightText", "TitleText", "Window", "WindowText", "ScrollBar",
    "InactiveTitle", "GradientInactiveTitle", "Menu", "WindowFrame",
    "MenuText", "ActiveBorder", "InactiveBorder", "AppWorkspace",
    "ButtonFace", "ButtonShadow", "GrayText", "ButtonText",
    "InactiveTitleText", "ButtonHilight", "ButtonDkShadow", "ButtonLight",
    "InfoText", "InfoWindow"};

// tCyz
const char* MyColorDesc[] =
    {"ϥΤDC", "hϥΤDC", "ୱ", "",
    "ؤr", "ϥΤDr", "", "r", "b",
    "DϥΤDC", "hDϥΤDC", "\", "",
    "\r", "ϥΤ", "DϥΤ", "ε{I",
    "骫", "sv", "Ǧr", "sr",
    "DϥΤDr", "sG", "骫t⳱v", "骫󰪫G",
    "ܤr", ""};

// GetSysColor  SetSysColors API ϥ
const int MyColorNo[] =
    {COLOR_ACTIVECAPTION, COLOR_GRADIENTACTIVECAPTION, COLOR_BACKGROUND,
    COLOR_HIGHLIGHT, COLOR_HIGHLIGHTTEXT, COLOR_CAPTIONTEXT, COLOR_WINDOW,
    COLOR_WINDOWTEXT, COLOR_SCROLLBAR, COLOR_INACTIVECAPTION,
    COLOR_GRADIENTINACTIVECAPTION, COLOR_MENU, COLOR_WINDOWFRAME,
    COLOR_MENUTEXT, COLOR_ACTIVEBORDER, COLOR_INACTIVEBORDER,
    COLOR_APPWORKSPACE, COLOR_BTNFACE, COLOR_BTNSHADOW, COLOR_GRAYTEXT,
    COLOR_BTNTEXT, COLOR_INACTIVECAPTIONTEXT, COLOR_BTNHIGHLIGHT,
    COLOR_3DDKSHADOW, COLOR_3DLIGHT, COLOR_INFOTEXT, COLOR_INFOBK};

// ΩtεnΧGyz
const char* MyCursorID[] =
    {"Arrow", "Help", "AppStarting", "Wait", "NWPen",
    "No", "SizeNS", "SizeWE", "Crosshair", "IBeam", "SizeNWSE",
    "SizeNESW", "SizeAll", "UpArrow"};

// SetSystemCursor API ϥ
const int MyCursorNo[] =
    {OCR_NORMAL, OIC_QUES, OCR_APPSTARTING, OCR_WAIT, OCR_IBEAM,
    OCR_NO, OCR_SIZENS, OCR_SIZEWE, OCR_CROSS, OCR_IBEAM, OCR_SIZENWSE,
    OCR_SIZENESW, OCR_SIZEALL, OCR_UP};

// {}} LoadImage API ϥ, J Windows w]
const int MyCursorNo1[] =
    {0x64, 0x70, 0x6F, 0x66, 0x65, 0x6E, 0x6C, 0x6B, 0x67, 0x65, 0x69,
    0x6A, 0x6D, 0x68};

// ƹдyz
const char* MyCursorDesc[] =
    {"@", "", "u@", "L", "r",
    "i", "վ", "վ", "T", "g", "uվ 1",
    "uվ 2", "", "䥦"};

// tέ: ΩtεnΧGyz
const char* MySoundSect[] =
    {".Default\\.Default\\.Current", // w]n
    ".Default\\AppGPFault\\.Current", // {~
    ".Default\\Maximize\\.Current", // ̤j
    ".Default\\MenuCommand\\.Current", // \O
    ".Default\\MenuPopup\\.Current", // \
    ".Default\\Minimize\\.Current", // ̤p
    ".Default\\Open\\.Current", // }ҵ{
    ".Default\\Close\\.Current", // {
    ".Default\\RestoreDown\\.Current", // U٭
    ".Default\\RestoreUp\\.Current", // W٭
    ".Default\\RingIn\\.Current", // ӹq
    ".Default\\Ringout\\.Current", // ~
    ".Default\\SystemAsterisk\\.Current", // P
    ".Default\\SystemDefault\\.Current", // SystemDefault
    ".Default\\SystemExclamation\\.Current", // n
    ".Default\\SystemExit\\.Current", //  Windows
    ".Default\\SystemHand\\.Current", // 氱
    ".Default\\SystemQuestion\\.Current", // D
    ".Default\\SystemStart\\.Current", // Ұ Windows
    "Explorer\\EmptyRecycleBin\\.Current"};                 // Mzu귽^v

// tέ: Ūtεnnyz
const char* MySoundDescKey[] =
    {".Default",
    "AppGPFault",
    "Maximize",
    "MenuCommand",
    "MenuPopup",
    "Minimize",
    "Open",
    "Close",
    "RestoreDown",
    "RestoreUp",
    "RingIn",
    "Ringout",
    "SystemAsterisk",
    "SystemDefault",
    "SystemExclamation",
    "SystemExit",
    "SystemHand",
    "SystemQuestion",
    "SystemStart",
    "EmptyRecycleBin"};

const char* MyFontDesc[] =
    {"ϥܤr", "DC", "OD", "\", "AC", "T"};

const char* MyIconDesc[] =
    {"ڪq", "WھF", "귽^{}", "귽^{}"};

const char* MyDesktopDesc[] =
    {"६", "I˦", "ùO@", "]w"};


  // ୱϥ: ΩtεnΧGyz
VAR const char* secMyComputer    INI(
    "CLSID\\{20D04FE0-3AEA-1069-A2D8-08002B30309D}\\DefaultIcon");
VAR const char* secNeighbor      INI(
    "CLSID\\{208D2C60-3AEA-1069-A2D7-08002B30309D}\\DefaultIcon");
VAR const char* secRecycleBin    INI(
    "CLSID\\{645FF040-5081-101B-9F08-00AA002F954E}\\DefaultIcon");

  // ³J Windows 98 beh[F "Software\\Classes\\" r
VAR const char* secMyComputerKey INI(
"Software\\Classes\\CLSID\\{20D04FE0-3AEA-1069-A2D8-08002B30309D}\\DefaultIcon");
VAR const char* secNeighborKey   INI(
"Software\\Classes\\CLSID\\{208D2C60-3AEA-1069-A2D7-08002B30309D}\\DefaultIcon");
VAR const char* secRecycleBinKey INI(
"Software\\Classes\\CLSID\\{645FF040-5081-101B-9F08-00AA002F954E}\\DefaultIcon");

VAR const char* sInactiveWindow  INI("DϥΤ");
VAR const char* sActiveWindow    INI("ϥΤ");
VAR const char* sWindowText      INI("r");
VAR const char* sMessageBox      INI("T");
VAR const char* sMessageText     INI("Tr");
VAR const char* sOK              INI("Tw");
VAR const char* sHint            INI("");

VAR const char* sNormal          INI("`");
VAR const char* sDisabled        INI("");
VAR const char* sSelected        INI("w");

VAR bool StringToBuffer(AnsiString S, void* Buf, int Size);
VAR AnsiString BufferToString(void* Buf, int Size);

VAR HCURSOR MyLoadCursor(TMyCursor No, AnsiString FileName);
VAR AnsiString GetMyWallPaperFile();

VAR TColor CalcForeColor(TColor mc);

#endif
