//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <Registry.hpp>

#include "ConfigDlgU.h"
#include "util.h"
#include "xFonts.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TConfigDlg *ConfigDlg;
//---------------------------------------------------------------------------
__fastcall TConfigDlg::TConfigDlg(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TConfigDlg::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  if (ModalResult == mrOk) SaveIni();
}
//---------------------------------------------------------------------------

void __fastcall TConfigDlg::trbSpeedChange(TObject *Sender)
{
  lblSpeed->Caption = Format("%d B", OPENARRAY(TVarRec, (trbSpeed->Position)));
}
//---------------------------------------------------------------------------
void __fastcall TConfigDlg::LoadIni()
{
  TRegIniFile* r = new TRegIniFile(REGISTRY_KEY);
  try {
    // ]w
    trbSpeed->Position = r->ReadInteger(SEC_GENERAL, REG_MOVESPEED, 5);
    trbSpeedChange(trbSpeed);

    // ܭ
    sedDelayTime->Value = r->ReadInteger(SEC_GENERAL, REG_MOVEDELAYTIME, 10);
    sedClearDelayTime->Value = r->ReadInteger(SEC_GENERAL, REG_CLEARDELAYTIME, 10);
    sedChangeDelayTime->Value = r->ReadInteger(SEC_GENERAL, REG_CHANGEDELAYTIME, 5000);

    txtFont->Text = r->ReadString(SEC_GENERAL, REG_DISPLAYFONT, DEFAULT_DISPLAYFONT);

    // uɮ
    r->ReadSection(SEC_ESSAYFILES, lbxFiles->Items);
  } __finally {
    delete r;
  }
}
//---------------------------------------------------------------------------
void __fastcall TConfigDlg::SaveIni()
{
  TRegIniFile* r = new TRegIniFile(REGISTRY_KEY);
  try {
    // ]w
    r->WriteInteger(SEC_GENERAL, REG_MOVESPEED, trbSpeed->Position);

    r->WriteInteger(SEC_GENERAL, REG_MOVEDELAYTIME, sedDelayTime->Value);
    r->WriteInteger(SEC_GENERAL, REG_CLEARDELAYTIME, sedClearDelayTime->Value);
    r->WriteInteger(SEC_GENERAL, REG_CHANGEDELAYTIME, sedChangeDelayTime->Value);

    // ܭ
    r->WriteString(SEC_GENERAL, REG_DISPLAYFONT, txtFont->Text);

    // uɮ
    r->EraseSection(SEC_ESSAYFILES);
    for (int i = 0; i < lbxFiles->Items->Count; i++)
      r->WriteString(SEC_ESSAYFILES, lbxFiles->Items->Strings[i], "");
  } __finally {
    delete r;
  }
}

void __fastcall TConfigDlg::btnAddClick(TObject *Sender)
{
  if (dlgOpen->Execute() && lbxFiles->Items->IndexOf(dlgOpen->FileName) == -1)
    switch (((TComponent*)Sender)->Tag) {
      case 0: lbxFiles->Items->Add(dlgOpen->FileName);
              break;
      case 1: lbxFiles->Items->Strings[lbxFiles->ItemIndex] = dlgOpen->FileName;
              break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TConfigDlg::BitBtn3Click(TObject *Sender)
{
  if (lbxFiles->ItemIndex != -1)
    lbxFiles->Items->Delete(lbxFiles->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TConfigDlg::FormCreate(TObject *Sender)
{
  pgcConfig->ActivePage = TabSheet1;

  LoadIni();
}
//---------------------------------------------------------------------------

void __fastcall TConfigDlg::lbxFilesClick(TObject *Sender)
{
  mmoEssay->Lines->LoadFromFile(lbxFiles->Items->Strings[lbxFiles->ItemIndex]);
}
//---------------------------------------------------------------------------

void __fastcall TConfigDlg::btnChatFontClick(TObject *Sender)
{
  StringToFont(txtFont->Text, dlgFont->Font, true);

  if (dlgFont->Execute()) {
    txtFont->Text = FontToString(dlgFont->Font, true);
    pbxFont->Invalidate();
  }
}
//---------------------------------------------------------------------------

void __fastcall TConfigDlg::pbxFontPaint(TObject *Sender)
{
  StringToFont(txtFont->Text, pbxFont->Canvas->Font, true);
  pbxFont->Canvas->FillRect(pbxFont->Canvas->ClipRect);

  pbxFont->Canvas->TextOut(4, 4, "Hi, oOdҤr");
}
//---------------------------------------------------------------------------

