//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DrawThrd.h"
#include "xFonts.hpp"

#include <registry.hpp>
#include "util.h"

#pragma package(smart_init)
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall Unit1::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall TDrawThread::TDrawThread(HWND Wnd)
        : TThread(false)
{
  randomize();
  
  FreeOnTerminate = True;

  FWnd = Wnd;

  FEssay = new TStringList;

  TRegIniFile* r = new TRegIniFile(REGISTRY_KEY);
  try {
    FMoveSpeed = r->ReadInteger(SEC_GENERAL, REG_MOVESPEED, 5);
    FDelayTime = r->ReadInteger(SEC_GENERAL, REG_MOVEDELAYTIME, 10);
    FClearDelayTime = r->ReadInteger(SEC_GENERAL, REG_CLEARDELAYTIME, 10);
    FChangeDelayTime = r->ReadInteger(SEC_GENERAL, REG_CHANGEDELAYTIME, 5000);
  } __finally {
    delete r;
  }

  GetClientRect(FWnd, &FWindowRect);
  FWindowWidth = FWindowRect.Right;
  FWindowHeight = FWindowRect.Bottom;
  FWindowMiddleY = FWindowHeight / 2;
}
//---------------------------------------------------------------------------
__fastcall TDrawThread::~TDrawThread()
{
  delete FEssay;
}
//---------------------------------------------------------------------------
void __fastcall TDrawThread::Execute()
{
  do {
    ChooseAndLoadEssay(); // ܨøJ@gu
    DisplayEssay(); // ثeu
  } while (!Terminated);
}
//---------------------------------------------------------------------------
void __fastcall TDrawThread::ChooseAndLoadEssay()
{
  TStrings* Files;

  Files = new TStringList;
  try {
    TRegIniFile* r = new TRegIniFile(REGISTRY_KEY);
    try {
      r->ReadSection(SEC_ESSAYFILES, Files);
    } __finally {
      delete r;
    }

    if (!Files->Count) { // S]wu
      FEssay->Clear();
      FEssay->Add("S]wu");
      return;
    }
    
    if (Files->Count == 1) // u@Ӫ, So
      FCurEssayFile = Files->Strings[0];
    else {
      int i;
      do { // Hüƿܤ@ӻPثePu
        i = random(Files->Count);
      } while (Files->Strings[i] == FCurEssayFile);

      FCurEssayFile = Files->Strings[i];
    }

    // Ju
    try {
      FEssay->LoadFromFile(FCurEssayFile);
    } catch(...) {
      FEssay->Add("LkJɮ " + FCurEssayFile);
    }
  } __finally {
    delete Files;
  }
}
//---------------------------------------------------------------------------
void __fastcall TDrawThread::DisplayEssay()
{
  TCanvas* Canvas = new TCanvas;
  Canvas->Handle = GetDC(FWnd);

  // ]wr, Cⵥ
  TRegIniFile* r = new TRegIniFile(REGISTRY_KEY);
  try {
    StringToFont(r->ReadString(SEC_GENERAL, REG_DISPLAYFONT, DEFAULT_DISPLAYFONT), Canvas->Font, true);
  } __finally {
    delete r;
  }

#define MAX(a,b) ((a)>(b)?(a):(b))
  
  // ӵYprβʳt
  if (FWindowHeight != Screen->Height) {
    Canvas->Font->Size = MAX((FWindowHeight * Canvas->Font->Size) / Screen->Height, 1);
    FMoveSpeed = MAX((FWindowHeight * FMoveSpeed) / Screen->Height, 1);
  }

  // m
  SetTextAlign(Canvas->Handle, TA_CENTER);
  // o氪
  TTextMetric TextMetric;
  GetTextMetrics(Canvas->Handle, &TextMetric);
  int LineHeight = (TextMetric.tmHeight + TextMetric.tmExternalLeading) * 3 / 2;

  Canvas->Brush->Style = bsSolid;
  Canvas->Brush->Color = clBlack;
      
  TRect R = FWindowRect;
  FWindowRect.Top = LineHeight;
      
  int TopMost = LineHeight; // r̰I
  int BottomMost = FWindowHeight - LineHeight * 2; // ŗCI
      
  int LineIndex = 0; // qĹs}l
  do {
    // q̤U]W
    int y = FWindowHeight;
    int OldY = y;

    R.Top = R.Bottom; // Ĥ@MFF

    // FTme (YWثe̩UCre)
    do {
      Canvas->FillRect(R); // MӪr
      Canvas->TextOut(FWindowWidth / 2, y, FEssay->Strings[LineIndex]);

      R.Top = y;
      R.Bottom = OldY + LineHeight;
      OldY = y; // s OldY

      y -= FMoveSpeed;

      // ץ y , Y֭nIW@F, h y Tw
      if (y - BottomMost < FMoveSpeed)
        y = BottomMost;
          
      if (FDelayTime) Sleep(FDelayTime); // 
    } while (y != BottomMost && !Terminated);

    if (Terminated) break;

    // H̷s y , Ae@
    Canvas->FillRect(R); // MӪr
    Canvas->TextOut(FWindowWidth / 2, y, FEssay->Strings[LineIndex]);

    // pʳWy
    if (TopMost > LineHeight)
      R.Top = TopMost;
    else
      R.Top = TopMost + LineHeight; // 묹@

    R.Bottom = BottomMost + LineHeight; // ثeUt
    int ScrollFinalY = R.Top - LineHeight; // ʳ̲צm

    // eWҦr̤r`it׽wwWʤ@
    while (R.Top > ScrollFinalY && !Terminated) {
      ScrollWindow(FWnd, 0, -FMoveSpeed, &R, &FWindowRect);
      R.Top -= FMoveSpeed;
      R.Bottom -= FMoveSpeed;
      if (FDelayTime) Sleep(FDelayTime);
    }

    // srm
    TopMost = R.Top;
    BottomMost = R.Bottom;

    LineIndex++;
  } while (LineIndex < FEssay->Count && !Terminated);

  // L𮧮ɶ
  if (FChangeDelayTime) Sleep(FChangeDelayTime);

  // ѥ~Ӥ, NeWҦFFM
  for (int x = 0; x <= FWindowWidth / 2; x++) {
    if (Terminated) return;

    Canvas->MoveTo(x, 0);
    Canvas->LineTo(x, FWindowHeight);
    Canvas->MoveTo(FWindowWidth - x, 0);
    Canvas->LineTo(FWindowWidth - x, FWindowHeight);

    if (FClearDelayTime) Sleep(FClearDelayTime);
  }

  ReleaseDC(FWnd, Canvas->Handle);
  delete Canvas;
}
